#!/usr/bin/env phantomjs
(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";
var system = require("system"),
    fs = require("fs"),
    router = require("./router"),
    getPass = require("./get-pass");

var argv = system.args,
    quantity = parseFloat(argv[1], 10);

if (argv.length !== 2 || isNaN(quantity)) {
  console.log(argv[0], "[quantity]");
  phantom.exit(1);
}

router.navigate("http://account.skrill.com");

router.set("https://account.skrill.com/login", function () {
  var _this = this;
  console.log("logging in");

  getPass("skrill", function (err, pass, email) {
    if (err) return error(err);
    _this.evaluate(function (pass, email) {
      $("#user_authentication_email").val(email).change();
      $("#user_authentication_password").val(pass).change();
      $("[name=commit]").click();
    }, pass, email);
  });
});

router.set("https://account.skrill.com/dashboard", function () {
  console.log("Balance:", this.evaluate(function () {
    return $("#account-panel .balance").text();
  }));

  dashboard();
});

function dashboard() {
  if (quantity) router.navigate("https://account.skrill.com/fund_uploads/new");else phantom.exit();
}

router.set("https://account.skrill.com/fund_uploads/new", function () {
  this.evaluate(function () {
    $("#fund_upload_fund_upload_method_bank").click();
    $("#fund_upload_payment_option_ideal").click();
    $("#fund_upload_issuer").val("ABNANL2A").change();
    $("[name=commit]").click();
  });
});

router.set("https://account.skrill.com/fund_uploads/bank_uploads/step/1", function () {
  this.evaluate(function (quantity) {
    if (typeof $ == "undefined") return;
    $("#fund_upload_amount").val(quantity).change();
    $("[name=commit]").click();
  }, quantity);
});

router.set("https://www.abnamro.nl/en/ideal/identification.do", identify);
router.set("https://www.abnamro.nl/en/ideal/mobile.do", identify);

function identify() {
  var _this = this;
  getPass("abnamro", function (err, _, account, card) {
    if (err) return error(err);
    _this.evaluate(function (account, card) {
      $("#e2Radio").click().change();
      $("[name=accountNumber]").val(account).change();
      $("[name=cardNumber]").val(card).change();
      $("[name=buttonContinue]").click();
    }, account, card);
  });
}

router.set("https://www.abnamro.nl/en/ideal/unconnected.do", function () {
  console.log("Challenge:", this.evaluate(function () {
    return document.querySelector(".challengenew").textContent;
  }));

  this.evaluate(function (response) {
    document.querySelector("[name=response]").value = response;
    document.querySelector("form").submit();
  }, system.stdin.readLine());
});

router.set("https://www.abnamro.nl/en/ideal/selectdebitaccount.do", function () {
  this.evaluate(function () {
    document.querySelector("form").submit();
  });
});

router.set("https://www.abnamro.nl/en/ideal/confirm.do", function () {
  this.evaluate(function () {
    window.location = document.querySelector("[src=\"./imgs/bttn/bestelling_afronden.gif\"]").parentNode.href;
  });

  quantity = null;
});

function error(err) {
  console.error(err);
  phantom.exit(1);
}

},{"./get-pass":2,"./router":3,"fs":"fs","system":"system"}],2:[function(require,module,exports){
"use strict";
var _toConsumableArray = function (arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } };

var spawn = require("child_process").spawn;

module.exports = function getPass(service, cb) {
  var child = spawn("pass", ["show", service]),
      stdout = "",
      stderr = "";

  child.stdout.on("data", function (chunk) {
    stdout += chunk;
  });
  child.stderr.on("data", function (chunk) {
    stderr += chunk;
  });

  child.on("exit", function (code) {
    if (code !== 0) {
      var err = new Error("failed to acquire password: " + stderr);
      return cb(err);
    }

    var data = stdout.split("\n"),
        pass = data[0],
        user = data[1];

    cb.apply(undefined, [null].concat(_toConsumableArray(data)));
  });
};

},{"child_process":"child_process"}],3:[function(require,module,exports){
"use strict";
var routes = Object.create(null),
    router = exports;

var page = require("webpage").create();
page.viewportSize = { width: 1366, height: 768 };

router.navigate = function () {
  var args = [].slice.call(arguments);
  args.push(dispatch);
  return page.open.apply(page, args);
};

router.set = function (url, handler) {
  routes[url] = handler;
};

function dispatch(status) {
  page.onLoadFinished = dispatch;

  var url = page.url;
  if (status && status !== "success") {
    var err = new Error("failed to load " + url);
    throw err;
  }

  var cb = routes[url.replace(/\?.*$/, "")];
  if (cb) {
    console.log("dispatching", url);
    return cb.call(page);
  }
  console.log("waiting at", url);
}

},{"webpage":"webpage"}]},{},[1]);
